/*
  InitialConfig.hpp
  Copyright (C) 2013  Giménez, Christian N.
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  
  jueves 24 de enero del 2013     */


#ifndef __INITIALCONFIG_HPP
#define __INITIALCONFIG_HPP 1

#include <string>

using namespace std;

#include "Terminal.hpp"

using namespace Terminal;

/**
   I encapsulate all the initial configuration for general use.
 */
class InitialConfig {

protected:
  /**
     An instance of string with the initial world name.
   */
  string initial_world;

  /**
     An instance of string with the initial location name from the initial world.
   */
  string initial_location;

  /**
     This is the starting position of the character. 
     
     The PC will start on the initial world, the initial location at this starting position.
   */
  float starting_pos[3];

public:
  /**
     Create an instance of InitialConfig with the default values.
   */
  InitialConfig();
  ~InitialConfig();

  /**
     @name Getters y Setters
  */
  //@{
  void set_starting_pos(float pos[3]);
  /**
     @return An instance of array with three elements: X,Y,Z.
   */
  float* get_starting_pos();
  
  void set_initial_location(string locationname);
  string get_initial_location();

  void set_initial_world(string worldname);
  string get_initial_world();
  //@}
  
};

#endif /* __INITIALCONFIG_HPP */

