
    // Location.cpp
    // Copyright (C) 2013  Giménez, Christian N.

    // This program is free software: you can redistribute it and/or modify
    // it under the terms of the GNU General Public License as published by
    // the Free Software Foundation, either version 3 of the License, or
    // (at your option) any later version.

    // This program is distributed in the hope that it will be useful,
    // but WITHOUT ANY WARRANTY; without even the implied warranty of
    // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    // GNU General Public License for more details.

    // You should have received a copy of the GNU General Public License
    // along with this program.  If not, see <http://www.gnu.org/licenses/>.

    // Miércoles 23 De Enero Del 2013    


#include "Location.hpp"

#include "Terminal.hpp"

using namespace Terminal;

#include "Light.hpp"

Location::Location(string name, string model_filename){
  Message::show("L",name);
  Message::show("L",model_filename);
  this->name = name;
  this->modelfile = model_filename;
  //this->texturename = "";
  //starting_pos.set(0.0, 0.0, 0.0);
  Message::show("Location", "I'm fine! :)");
}

// Location::Location(stringc name, stringc model, vector3df starting_pos){
//   this->name = name;
//   this->model = model;
//   this->texturename = "";
//   this->starting_pos = starting_pos;
//   mesh = NULL;
//   node = NULL;
// }

Location::~Location(){
  delete(entity);
  delete(scene_node);
}

void Location::load(Ogre::SceneManager* smgr){
  Message::show("Location", "Loading location...");
  Message::show("Location", modelfile);
  
  entity = smgr->createEntity(name, modelfile);
  
  scene_node = smgr->getRootSceneNode()->createChildSceneNode();
  scene_node->attachObject(entity);

  
  smgr->setAmbientLight(Ogre::ColourValue(1.0, 1.0, 1.0));

  //Load all lights
  load_lights(smgr);
}

// void Location::setTexturename(string name){
//   this->texturename = name;
// }

// string Location::getTexturename(){
//   return this->texturename;
// }

void Location::add_light(Light *l){
  col_lights.push_back(l);
}

void Location::add_light(string name, float* dir, float* color){
  Message::show("L", "add_light(string,float,float)");

  Light *l = new Light(name);
  
  l->set_dir(dir);
  l->set_color(color);

  col_lights.push_back(l); 

  Message::show("L", "Light added");
}

void Location::load_lights(Ogre::SceneManager *smgr){
  std::vector<Light*>::iterator it = col_lights.begin();

  Light* light;

  while (it != col_lights.end()){
    light = *it;
    light->load(smgr);
    ++it;
  }
}

// void Location::setStart(vector3df pos){
//   starting_pos = pos;
// }

// vector3df Location::getStart(){
//   return starting_pos;
// }


// IMeshSceneNode* Location::get_node(){
//   return node;
// }

// void Location::set_initial_position(ISceneNode* node){
//   node->setPosition(starting_pos);
// }
