
/*
  MyKeyListener.cpp
  Copyright (C) 2013  Giménez, Christian N. 
  
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 
  
  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
  GNU General Public License for more details. 
  
  You should have received a copy of the GNU General Public License 
  along with this program.  If not, see <http://www.gnu.org/licenses/>. 
  
  lunes 14 de enero del 2013    */

#include "MyKeyListener.hpp"
#include <iostream>

using namespace std;

MyKeyListener::MyKeyListener(TinyOgre *tiny) : 
  OIS::KeyListener(){

  this->tiny = tiny;
  last_key_event = NULL;

}

MyKeyListener::~MyKeyListener() {
}

bool MyKeyListener::keyPressed(const OIS::KeyEvent  &ke){

  Ogre::SceneManager* smgr = tiny->getSceneMgr();
  Ogre::Camera* cam = smgr->getCamera("PlayerCam");
  

  /**
     TODO: No estoy muy seguro de esto.
  */
  setLastKeyEvent(ke);
 
  switch (ke.key){
    
  case OIS::KC_ESCAPE :
    tiny->terminar();
    exit(0);
    return false;    
    break;

  case OIS::KC_C:
    tiny->cam_toggle_mode();
    break;

  case OIS::KC_R:
    cam->moveRelative(Ogre::Vector3(0,1,0));
    break;
  case OIS::KC_F:
    cam->moveRelative(Ogre::Vector3(0,-1,0));
    break;
  case OIS::KC_W :    
    tiny->pc_forward();
    break;

  case OIS::KC_S :
    tiny->pc_backwards();
    break;

  case OIS::KC_A:
    tiny->pc_strafe_left();
    break;

  case OIS::KC_D:
    tiny->pc_strafe_right();
    break;


  case OIS::KC_Q:
    tiny->pc_rot_left();
    break;

  case OIS::KC_E:
    tiny->pc_rot_right();
    break;

  case OIS::KC_UP:
    cam->pitch(Ogre::Radian(0.01));
    break;

  case OIS::KC_DOWN:
    cam->pitch(Ogre::Radian(-0.01));
    break;

  case OIS::KC_LEFT:
    cam->yaw(Ogre::Radian(0.01));
    break;

  case OIS::KC_RIGHT:
    cam->yaw(Ogre::Radian(-0.01));
    break;

  case OIS::KC_PGUP:
    cam->roll(Ogre::Radian(0.01));
    break;
    
  case OIS::KC_PGDOWN:
    cam->roll(Ogre::Radian(-0.01));
    break;
    
  case OIS::KC_K:
    cam->moveRelative(Ogre::Vector3(0,0,1));
    break;

  case OIS::KC_L:
    cam->moveRelative(Ogre::Vector3(0,0,-1));
    break;

  case OIS::KC_J:
    cam->moveRelative(Ogre::Vector3(0,1,0));
    break;

  case OIS::KC_H:
    cam->moveRelative(Ogre::Vector3(0,-1,0));
    break;

  default:    
    break;

  }
  
  return true;
}

void MyKeyListener::repeatKeyEvent(){
  if (last_key_event != NULL){
    this->keyPressed(*last_key_event);
  }
}

bool MyKeyListener::keyReleased(const OIS::KeyEvent  &ke){
  last_key_event = NULL;
}

void MyKeyListener::setLastKeyEvent(OIS::KeyEvent ke){
  last_key_event = new OIS::KeyEvent(NULL, ke.key, ke.text);  
}
