
    // PC.cpp
    // Copyright (C) 2013  Giménez, Christian N.

    // This program is free software: you can redistribute it and/or modify
    // it under the terms of the GNU General Public License as published by
    // the Free Software Foundation, either version 3 of the License, or
    // (at your option) any later version.

    // This program is distributed in the hope that it will be useful,
    // but WITHOUT ANY WARRANTY; without even the implied warranty of
    // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    // GNU General Public License for more details.

    // You should have received a copy of the GNU General Public License
    // along with this program.  If not, see <http://www.gnu.org/licenses/>.

    // Jueves 02 De Mayo Del 2013    


#include "PC.hpp"
#include <math.h>

PC::PC(string name, string model_name, Location *location, float initial_angle) :
  Character(name, model_name, location, initial_angle){

  // cam_angle = 1.57;
  // cam_elevation = 1.57;
  cam_distance = PC_MAXCAMDISTANCE;
  camera = NULL;

  first_person = false;
}

/*PC::PC(ICameraSceneNode* camera, string model_name, Location *location) :
  Character(camera, model_name, location){

  set_camera(camera);
  distance = 50;
  angle = 90;
  }*/

PC::~PC(){
}

void PC::set_camera(Ogre::Camera* camera){
  this->camera = camera;
  
  if (scene_node != NULL){
    scene_node->attachObject(camera);
  }
}


Ogre::Camera* PC::get_camera(){
  return camera;
}


void PC::load(Ogre::SceneManager *smgr){
  Character::load(smgr);

  if (camera){
    scene_node->attachObject(camera); 
  }

  update_camera();
}

// void PC::forward(){
//   Character::forward();
//   camera->setTarget(node->getPosition());  
// }


// void PC::backward(){
//   Character::backward();
//   camera->setTarget(node->getPosition());
// }


// void PC::left(){
//   Character::left();
//   camera->setTarget(node->getPosition());  
// }

// void PC::right(){
//   Character::right();
//   camera->setTarget(node->getPosition());  
// }


// void PC::camera_nearer(){
//   if (cam_distance < PC_MINCAMDISTANCE){
//     return;
//   }    

//   cam_distance -= PC_CAMDISTANCESTEP;
//   update_camera();
// }

// void PC::camera_farer(){
//   if (cam_distance > PC_MAXCAMDISTANCE){
//     return;
//   }
  
//   cam_distance += PC_CAMDISTANCESTEP;
//   update_camera();
// }

// void PC::camera_rot_right(){
//   if (cam_angle > PC_MAXCAMANGLE){
//     cam_angle = PC_MINCAMANGLE;
//   }
  
//   cam_angle += PC_CAMANGLESTEP;
//   update_camera();
// }

// void PC::camera_rot_left(){
//   if (cam_angle < PC_MINCAMANGLE){
//     cam_angle = PC_MAXCAMANGLE;
//   }  

//   cam_angle -= PC_CAMANGLESTEP;  
//   update_camera();
// }

// void PC::camera_lower(){
//   if (cam_elevation > PC_MAXCAMELEVATION){
//     return;
//   }

//   cam_elevation += PC_CAMELEVATIONSTEP;
//   update_camera();
// }

// void PC::camera_raise(){
//   if (cam_elevation < PC_MINCAMELEVATION){
//     return;
//   }

//   cam_elevation -= PC_CAMELEVATIONSTEP;
//   update_camera();
// }

void PC::update_camera(){
  // float x,y,z;
  // x = cos(cam_angle) * cam_distance;
  // y = sin(cam_elevation) * cam_distance;
  // z = sin(cam_angle) * cam_distance;
  
  // camera->setPosition(x,y,z);
  // camera->lookAt(scene_node->getPosition());

  if (!camera){
    return;
  }
  
  // camera->setPosition(0, 10, -10);

  camera->setPosition(0,0,0);

  if (!first_person){   
    camera->moveRelative(Ogre::Vector3(0,0,cam_distance));
  }
}


void PC::cam_third_person(){
  first_person = false;

  update_camera();
}

void PC::cam_first_person(){
  first_person = true;

  update_camera();
}

bool PC::toggle_camera_mode(){
  first_person = !first_person;

  update_camera();

  return first_person;
}

